Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_endpoint.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_endpoint.hpp	(revision 1539)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_endpoint.hpp	(revision 1539)
@@ -0,0 +1,26 @@
+#ifndef EP_LIB_ENDPOINT_HPP_INCLUDED
+#define EP_LIB_ENDPOINT_HPP_INCLUDED
+
+namespace ep_lib
+{
+
+  typedef void* MPI_Datatype;
+  typedef void* MPI_Op;
+
+
+  int MPI_Barrier_endpoint(MPI_Comm comm);
+
+  int MPI_Comm_free_endpoint(MPI_Comm* comm);
+
+  int Message_Check_endpoint(MPI_Comm comm);
+  
+  int MPI_Comm_dup_endpoint(MPI_Comm comm, MPI_Comm *newcomm);
+  
+  int MPI_Iprobe_endpoint(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
+  int MPI_Improbe_endpoint(int source, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);
+  
+  int MPI_Intercomm_create_endpoint(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
+
+}
+
+#endif // EP_LIB_ENDPOINT_HPP_INCLUDED
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_intercomm.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_intercomm.hpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_intercomm.hpp	(revision 1539)
@@ -8,29 +8,28 @@
   typedef void* MPI_Op;
 
-  int MPI_Send_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
-  int MPI_Ssend_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
-  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
+  int MPI_Allgather_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
+  int MPI_Allgatherv_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, const int recvcounts[], const int displs[], MPI_Datatype recvtype, MPI_Comm comm);
 
-  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
+  int MPI_Allreduce_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
 
+  int MPI_Alltoall_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
 
-  int MPI_Comm_dup_intercomm(MPI_Comm comm, MPI_Comm *newcomm);
+  int MPI_Bcast_intercomm(void *buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm);
 
-  int MPI_Comm_free_intercomm(MPI_Comm* comm);
+  int MPI_Exscan_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
+  int MPI_Scan_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
 
-  int MPI_Barrier_intercomm(MPI_Comm comm);
+  int MPI_Gather_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm);
 
-  int Message_Check_intercomm(MPI_Comm comm);
+  int MPI_Gatherv_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, const int input_recvcounts[], const int input_displs[],
+                            MPI_Datatype recvtype, int root, MPI_Comm comm);
 
-  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
-  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
+  int MPI_Reduce_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, int root, MPI_Comm comm);
 
+  int MPI_Reduce_scatter_intercomm(const void *sendbuf, void *recvbuf, const int recvcounts[], MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
 
-  int MPI_Iprobe_intercomm(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
-  int MPI_Improbe_intercomm(int source, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);
-
-
-
-
+  int MPI_Scatter_intercomm(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm);
+  int MPI_Scatterv_intercomm(const void *sendbuf, const int sendcounts[], const int displs[], MPI_Datatype sendtype, void *recvbuf, int recvcount,
+                   MPI_Datatype recvtype, int root, MPI_Comm comm);
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_mpi.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_mpi.hpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_mpi.hpp	(revision 1539)
@@ -19,4 +19,5 @@
 
   int MPI_Iprobe_mpi(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
+  int MPI_Improbe_mpi(int src, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);
   
   int MPI_Comm_rank_mpi(MPI_Comm comm, int* rank);
@@ -29,5 +30,6 @@
   int MPI_Barrier_mpi(MPI_Comm comm);
   
-  int MPI_Abort_mpi(MPI_Comm comm, int errorcode);
+  int MPI_Intercomm_create_mpi(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
+
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_merge.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_merge.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_merge.cpp	(revision 1539)
@@ -10,193 +10,95 @@
 {
 
-  int MPI_Intercomm_merge_unique_leader(MPI_Comm inter_comm, bool high, MPI_Comm *newintracomm)
+  int MPI_Intercomm_merge(MPI_Comm inter_comm, bool high, MPI_Comm *newintracomm)
   {
-    Debug("intercomm_merge with unique leader\n");
+    
+    int ep_rank = inter_comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_size = inter_comm->ep_comm_ptr->size_rank_info[0].second;
+    int ep_rank_loc = inter_comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep = inter_comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_rank = inter_comm->ep_comm_ptr->size_rank_info[2].first;
 
+    int remote_ep_size = inter_comm->inter_rank_map->size();
 
-
-    int ep_rank, ep_rank_loc, mpi_rank;
-    int ep_size, num_ep, mpi_size;
-
-    ep_rank = inter_comm->ep_comm_ptr->size_rank_info[0].first;
-    ep_rank_loc = inter_comm->ep_comm_ptr->size_rank_info[1].first;
-    mpi_rank = inter_comm->ep_comm_ptr->size_rank_info[2].first;
-    ep_size = inter_comm->ep_comm_ptr->size_rank_info[0].second;
-    num_ep = inter_comm->ep_comm_ptr->size_rank_info[1].second;
-    mpi_size = inter_comm->ep_comm_ptr->size_rank_info[2].second;
-
-    int local_high = high;
-    int remote_high;
-
-    int remote_ep_size = inter_comm->ep_comm_ptr->intercomm->remote_rank_map->size();
-
-    int local_ep_rank, local_ep_rank_loc, local_mpi_rank;
-    int local_ep_size, local_num_ep, local_mpi_size;
-
-    //local_ep_rank = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].first;
-    //local_ep_rank_loc = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].first;
-    //local_mpi_rank = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].first;
-    //local_ep_size = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].second;
-    //local_num_ep = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].second;
-    //local_mpi_size = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].second;
-
-
-    if(local_ep_rank == 0)
-    {
-      MPI_Status status[2];
-      MPI_Request request[2];
-      MPI_Isend(&local_high, 1, MPI_INT, 0, inter_comm->ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &request[0]);
-      MPI_Irecv(&remote_high, 1, MPI_INT, 0, inter_comm->ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &request[1]);
-
-      MPI_Waitall(2, request, status);
-    }
-
-
-    //MPI_Bcast(&remote_high, 1, MPI_INT, 0, inter_comm->ep_comm_ptr->intercomm->local_comm);
-
+    int new_ep_rank = high? remote_ep_size + ep_rank : ep_rank;
 
 
     MPI_Comm_dup(inter_comm, newintracomm);
 
-    int my_ep_rank = local_high<remote_high? local_ep_rank: local_ep_rank+remote_ep_size;
+    (*newintracomm)->is_intercomm = false;
+    (*newintracomm)->inter_rank_map->clear();
+    delete (*newintracomm)->inter_rank_map;
+
+    (*newintracomm)->ep_comm_ptr->size_rank_info[0].second = ep_size + remote_ep_size;
+    
+    ///////////////////////////////////
+    int int_high = high? 1 : 0;
+    int sum_high;
+    
+    MPI_Allreduce(&int_high, &sum_high, 1, MPI_INT, MPI_SUM, *newintracomm);
+
+    if(sum_high==0 || sum_high==ep_size+remote_ep_size)
+    {
+      printf("MPI_Intercomm_merge error: please define high with different value...\n");
+      MPI_Abort(inter_comm, 0);
+    }
+    
+    
+    
+    ///////////////////////////////////
+    
+    (*newintracomm)->ep_comm_ptr->size_rank_info[0].first = new_ep_rank;
+
+    // modif ep_rank_map
+    int my_triple[3] = {new_ep_rank, ep_rank_loc, mpi_rank};
+    int *my_triple_list = new int[3*(ep_size+remote_ep_size)];
+
+    
+    MPI_Allgather(my_triple, 3, MPI_INT, my_triple_list, 3, MPI_INT, *newintracomm); 
 
 
-    int intra_ep_rank, intra_ep_rank_loc, intra_mpi_rank;
-    int intra_ep_size, intra_num_ep, intra_mpi_size;
+#ifdef _showinfo
+    for(int i=0; i<ep_size+remote_ep_size; i++)
+    {
+      if(new_ep_rank == i)
+      {
+        for(int j=0; j<ep_size+remote_ep_size; j++)
+        {
+          printf("rank %d : my_triple_list[%d] = %d %d %d\n", i, j, my_triple_list[3*j], my_triple_list[3*j+1], my_triple_list[3*j+2]);
+        }
+        printf("\n");
+      }
+      MPI_Barrier(*newintracomm);
+    }
+#endif
 
-    intra_ep_rank = (*newintracomm)->ep_comm_ptr->size_rank_info[0].first;
-    intra_ep_rank_loc = (*newintracomm)->ep_comm_ptr->size_rank_info[1].first;
-    intra_mpi_rank = (*newintracomm)->ep_comm_ptr->size_rank_info[2].first;
-    intra_ep_size = (*newintracomm)->ep_comm_ptr->size_rank_info[0].second;
-    intra_num_ep = (*newintracomm)->ep_comm_ptr->size_rank_info[1].second;
-    intra_mpi_size = (*newintracomm)->ep_comm_ptr->size_rank_info[2].second;
-
-
-    MPI_Barrier_local(*newintracomm);
-
-
-    int *reorder;
-    if(intra_ep_rank_loc == 0)
+    if((*newintracomm)->ep_comm_ptr->size_rank_info[1].first==0)
     {
-      reorder = new int[intra_ep_size];
-    }
-
-
-    MPI_Gather(&my_ep_rank, 1, MPI_INT, reorder, 1, MPI_INT, 0, *newintracomm);
-    if(intra_ep_rank_loc == 0)
-    {
-      ::MPI_Bcast(reorder, intra_ep_size, to_mpi_type(MPI_INT), 0, to_mpi_comm((*newintracomm)->mpi_comm));
-
-      vector< pair<int, int> > tmp_rank_map(intra_ep_size);
-
-
-      for(int i=0; i<intra_ep_size; i++)
+      for(int i=0; i<ep_size+remote_ep_size; i++)
       {
-        tmp_rank_map[reorder[i]] = (*newintracomm)->ep_rank_map->at(i) ;
+        (*newintracomm)->ep_comm_ptr->comm_list[0]->ep_rank_map->at(my_triple_list[3*i]) = std::make_pair(my_triple_list[3*i+1], my_triple_list[3*i+2]);
       }
-
-      //(*newintracomm)->rank_map->swap(tmp_rank_map);
-      (*newintracomm)->ep_rank_map->clear();
-      for(int i=0; i<tmp_rank_map.size(); i++)
-      {
-        (*newintracomm)->ep_rank_map->insert(std::pair< int, std::pair<int,int> >(i, tmp_rank_map[i].first, tmp_rank_map[i].second));
-      }
-      
-
-      tmp_rank_map.clear();
     }
 
     MPI_Barrier_local(*newintracomm);
 
-    (*newintracomm)->ep_comm_ptr->size_rank_info[0].first = my_ep_rank;
+#ifdef _showinfo
 
-    if(intra_ep_rank_loc == 0)
+    for(int i=0; i<ep_size+remote_ep_size; i++)
     {
-      delete[] reorder;
-    }
-
-    return MPI_SUCCESS;
-  }
-
-
-
-
-
-  int MPI_Intercomm_merge(MPI_Comm inter_comm, bool high, MPI_Comm *newintracomm)
-  {
-    
-
-    assert(inter_comm->is_intercomm);
-
-    // determine if only one MPI proc
-
-        // to be completed ......
-
-    // multiple MPI proc and high differs
-
-    int newcomm_ep_rank = inter_comm->ep_comm_ptr->intercomm->size_rank_info[0].first;
-    int newcomm_ep_rank_loc = inter_comm->ep_comm_ptr->intercomm->size_rank_info[1].first;
-    int newcomm_num_ep = inter_comm->ep_comm_ptr->intercomm->size_rank_info[1].second;
-
-    int ep_rank = inter_comm->ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = inter_comm->ep_comm_ptr->size_rank_info[1].first;
-    int num_ep = inter_comm->ep_comm_ptr->size_rank_info[1].second;
-
-    if(newcomm_ep_rank_loc == 0)
-    {
-      ::MPI_Comm *mpi_intracomm = new ::MPI_Comm;
-      ::MPI_Intercomm_merge(to_mpi_comm(inter_comm->ep_comm_ptr->intercomm->mpi_inter_comm), high, mpi_intracomm);
-      
-      MPI_Info info;
-      MPI_Comm *ep_comm;
-      MPI_Comm_create_endpoints(mpi_intracomm, newcomm_num_ep, info, ep_comm);
-
-      inter_comm->ep_comm_ptr->comm_list[0]->mem_bridge = ep_comm;
-    }
-
-    MPI_Barrier_local(inter_comm);
-
-    int remote_num_ep = newcomm_num_ep - num_ep;
-
-    *newintracomm = inter_comm->ep_comm_ptr->comm_list[0]->mem_bridge[high? remote_num_ep+ep_rank_loc : ep_rank_loc];
-
-    int ep_size = inter_comm->ep_comm_ptr->size_rank_info[0].second;
-    int remote_ep_size = inter_comm->ep_comm_ptr->intercomm->intercomm_rank_map->size();
-
-    //printf("ep_size = %d, remote_ep_size = %d\n", ep_size, remote_ep_size);
-
-    (*newintracomm)->ep_comm_ptr->size_rank_info[0].first = high? remote_ep_size+ep_rank : ep_rank;
-
-    int my_triple[3];
-    my_triple[0] = (*newintracomm)->ep_comm_ptr->size_rank_info[0].first;
-    my_triple[1] = (*newintracomm)->ep_comm_ptr->size_rank_info[1].first;
-    my_triple[2] = (*newintracomm)->ep_comm_ptr->size_rank_info[2].first;
-
-    int *my_triple_list = new int[3 * (*newintracomm)->ep_comm_ptr->size_rank_info[0].second];
-
-
-    MPI_Allgather(my_triple, 3, MPI_INT, my_triple_list, 3, MPI_INT, *newintracomm);
-
-    if((*newintracomm)->ep_comm_ptr->size_rank_info[1].first == 0)
-    {
-      (*newintracomm)->ep_rank_map->clear();
-      for(int i=0; i<(*newintracomm)->ep_comm_ptr->size_rank_info[0].second; i++)
+      if(new_ep_rank == i)
       {
-        (*newintracomm)->ep_rank_map->insert(std::pair< int, std::pair<int,int> >(my_triple_list[3*i], my_triple_list[3*i+1], my_triple_list[3*i+2]));
+        for(EP_RANK_MAP::iterator it = (*newintracomm)->ep_rank_map->begin(); it != (*newintracomm)->ep_rank_map->end(); it++)
+        {
+          printf("rank %d : ep_rank_map[%d] = %d %d\n", i, it->first, it->second.first, it->second.second);
+        }
+        printf("\n");
       }
-    }
-
-#ifdef _showinfo
-    MPI_Barrier_local(inter_comm);
-    if((*newintracomm)->ep_comm_ptr->size_rank_info[0].first == 15)
-    {
-      for(std::map<int, std::pair<int, int> >::iterator it = (*newintracomm)->ep_rank_map->begin(); it != (*newintracomm)->ep_rank_map->end(); it++)
-      {
-        printf("(%d  %d  %d)\n", it->first, it->second.first, it->second.second);
-      }
+      MPI_Barrier(*newintracomm);
     }
 #endif
-    
-    delete my_triple_list;
+
+    delete[] my_triple_list;
+
   }
   
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp	(revision 1539)
@@ -32,5 +32,5 @@
     std::list<MPI_Request* >::iterator it;
     
-//    show_EP_PendingRequests(EP_PendingRequests);
+    show_EP_PendingRequests(EP_PendingRequests);
     
     
@@ -81,9 +81,9 @@
       }
       
-      if((*(*it))->state == 0)
+      if((*(*it))->probed == false)
       {
         #pragma omp critical (_query0)
         {
-          MPI_Iprobe((*(*it))->ep_src, (*(*it))->ep_tag, ((*(*it))->comm), &probed, &status);
+          MPI_Iprobe_endpoint((*(*it))->ep_src, (*(*it))->ep_tag, ((*(*it))->comm), &probed, &status);
           if(probed)
           {
@@ -95,5 +95,5 @@
           
           
-            MPI_Improbe((*(*it))->ep_src, (*(*it))->ep_tag, (*(*it))->comm, &probed, message, &status);
+            MPI_Improbe_endpoint((*(*it))->ep_src, (*(*it))->ep_tag, (*(*it))->comm, &probed, message, &status);
         
           }
@@ -107,5 +107,5 @@
           MPI_Imrecv((*(*it))->buf, recv_count, (*(*it))->ep_datatype, message, *it);
           (*(*it))->type = 3;
-          (*(*it))->state = 1;
+          (*(*it))->probed = true;
 
           memcheck("delete "<< status.mpi_status <<" : in ep_lib::Request_Check, delete status.mpi_status");
@@ -133,17 +133,9 @@
   int Message_Check(MPI_Comm comm)
   {
-    if(!comm->is_ep) return MPI_SUCCESS;
-
-    if(comm->is_intercomm)
-    {
-      Message_Check_intercomm(comm);
-    }
-    
-    return Message_Check_intracomm(comm);
-
-  }
-  
-  
-  int Message_Check_intracomm(MPI_Comm comm)
+    if(comm->is_ep) return Message_Check_endpoint(comm);
+  }
+  
+  
+  int Message_Check_endpoint(MPI_Comm comm)
   {
     
@@ -204,71 +196,4 @@
   }
 
-
-  int Message_Check_intercomm(MPI_Comm comm)
-  {
-    if(!comm->ep_comm_ptr->intercomm->mpi_inter_comm) return 0;
-
-    Debug("Message probing for intercomm\n");
-
-    int flag = true;
-    ::MPI_Message message;
-    ::MPI_Status status;
-    int current_ep_rank;
-    MPI_Comm_rank(comm, &current_ep_rank);
-
-    while(flag) // loop until the end of global queue "comm->ep_comm_ptr->intercomm->mpi_inter_comm"
-    {
-      Debug("Message probing for intracomm\n");
-
-      #pragma omp critical (_mpi_call)
-      {
-        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), &flag, &status);
-        if(flag)
-        {
-          Debug("find message in mpi comm \n");
-          ::MPI_Mprobe(status.MPI_SOURCE, status.MPI_TAG, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), &message, &status);
-        }
-      }
-      
-
-      if(flag)
-      {
-
-        MPI_Message msg = new ep_message; 
-        msg->mpi_message = new ::MPI_Message(message);
-
-        memcheck("new "<< msg <<" : in ep_lib::Message_Check, msg = new ep_message");
-        memcheck("new "<< msg->mpi_message <<" : in ep_lib::Message_Check, msg->mpi_message = new ::MPI_Message");
-              
-
-        msg->ep_tag  = bitset<15>(status.MPI_TAG >> 16).to_ulong(); 
-        int src_loc  = bitset<8> (status.MPI_TAG >> 8) .to_ulong(); 
-        int dest_loc = bitset<8> (status.MPI_TAG)	    .to_ulong();
-        int src_mpi  = status.MPI_SOURCE;
-             
-        msg->ep_src  = get_ep_rank(comm, src_loc,  src_mpi);   
-#ifdef _showinfo
-        printf("status.MPI_TAG = %d, src_loc = %d, dest_loc = %d, ep_tag = %d\n", status.MPI_TAG, src_loc, dest_loc, msg->ep_tag);
-#endif
-
-        msg->mpi_status = new ::MPI_Status(status); 
-        memcheck("new "<< msg->mpi_status <<" : in ep_lib::Message_Check, msg->mpi_status = new ::MPI_Status");
-
-        #pragma omp critical (_query)
-        {
-          #pragma omp flush
-          comm->ep_comm_ptr->comm_list[dest_loc]->ep_comm_ptr->message_queue->push_back(msg);
-          memcheck("comm->ep_comm_ptr->comm_list["<<dest_loc<<"]->ep_comm_ptr->message_queue->size = "<<comm->ep_comm_ptr->comm_list[dest_loc]->ep_comm_ptr->message_queue->size());
-          #pragma omp flush
-        }
-      }
-    }
-
-    Message_Check_intracomm(comm);
-
-    return MPI_SUCCESS;
-  }
-  
-  
   
   void show_EP_PendingRequests(std::list< ep_lib::MPI_Request* > * EP_PendingRequest)
@@ -310,2 +235,3 @@
 
 }
+
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_probe.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_probe.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_probe.cpp	(revision 1539)
@@ -8,8 +8,41 @@
   int MPI_Iprobe_mpi(int src, int tag, MPI_Comm comm, int *flag, MPI_Status *status)
   {
+    ::MPI_Status mpi_status;
+
+    ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, &mpi_status);
+
+    status->mpi_status = new ::MPI_Status(mpi_status);
     status->ep_src = src;
     status->ep_tag = tag;
-    return ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, to_mpi_status_ptr(*status));
   }
+
+
+  int MPI_Improbe_mpi(int src, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status)
+  {
+    ::MPI_Status mpi_status;
+    ::MPI_Message mpi_message;
+
+    #ifdef _openmpi
+    #pragma omp critical (_mpi_call)
+    {
+      ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, &mpi_status);
+      if(*flag)
+      {
+        ::MPI_Mprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), &mpi_message, &mpi_status);
+      }
+    }
+    #elif _intelmpi
+    ::MPI_Improbe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, &mpi_message, &mpi_status);
+    #endif
+      
+    status->mpi_status = new ::MPI_Status(mpi_status);
+    status->ep_src = src;
+    status->ep_tag = tag;
+
+    (*message)->mpi_message = &message;
+    (*message)->ep_src = src;
+    (*message)->ep_tag = tag;
+  }
+
 
   int MPI_Iprobe(int src, int tag, MPI_Comm comm, int *flag, MPI_Status *status)
@@ -20,78 +53,82 @@
       return MPI_Iprobe_mpi(src, tag, comm, flag, status);
     }
+
+    if(comm->is_intercomm)
+    {
+      if(src>=0) src = comm->inter_rank_map->at(src);
+    } 
     
-    else
+    return MPI_Iprobe_endpoint(src, tag, comm, flag, status);
+  }
+
+  int MPI_Iprobe_endpoint(int src, int tag, MPI_Comm comm, int *flag, MPI_Status *status)
+  {
+    Debug("MPI_Iprobe with EP\n");
+
+    *flag = false;
+    
+    Message_Check(comm);
+
+    #pragma omp flush
+
+    #pragma omp critical (_query)
+    for(Message_list::iterator it = comm->ep_comm_ptr->message_queue->begin(); it!= comm->ep_comm_ptr->message_queue->end(); ++it)
     {
-      Debug("MPI_Iprobe with EP\n");
+      bool src_matched = src<0? true: (*it)->ep_src == src;
+      bool tag_matched = tag<0? true: (*it)->ep_tag == tag;
       
-      *flag = false;
-    
-      Message_Check(comm);
+      if(src_matched && tag_matched)        
+      {
+        Debug("find message\n");
+         
+        status->mpi_status = new ::MPI_Status(*static_cast< ::MPI_Status*>((*it)->mpi_status));
+        status->ep_src = (*it)->ep_src;
+        status->ep_tag = (*it)->ep_tag;
+        
+        if(comm->is_intercomm)
+        {
+          for(INTER_RANK_MAP::iterator iter = comm->inter_rank_map->begin(); iter != comm->inter_rank_map->end(); iter++)
+          {
+            if(iter->second == (*it)->ep_src) status->ep_src=iter->first;
+          }
+        }
 
-      #pragma omp flush
-
-      #pragma omp critical (_query)
-      for(Message_list::iterator it = comm->ep_comm_ptr->message_queue->begin(); it!= comm->ep_comm_ptr->message_queue->end(); ++it)
-      {
-        bool src_matched = src<0? true: (*it)->ep_src == src;
-        bool tag_matched = tag<0? true: (*it)->ep_tag == tag;
-        
-        if(src_matched && tag_matched)        
-        {
-          Debug("find message\n");
-          
-
-          status->mpi_status = new ::MPI_Status(*static_cast< ::MPI_Status*>((*it)->mpi_status));
-          status->ep_src = (*it)->ep_src;
-          status->ep_tag = (*it)->ep_tag;
-
-          *flag = true;
-          break;
-        }
+        *flag = true;
+        break;
       }
     }
   }
 
-
+  
 
   int MPI_Improbe(int src, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status)
   {
+    if(!comm->is_ep)
+    {
+      Debug("MPI_Iprobe with MPI\n");
+      return MPI_Improbe_mpi(src, tag, comm, flag, message, status);
+    }
+
+    if(comm->is_intercomm)
+    {
+      src = comm->inter_rank_map->at(src);
+      *message = new ep_message;
+      printf("============= new *message = %p\n", *message);
+    } 
+    
+    return MPI_Improbe_endpoint(src, tag, comm, flag, message, status);
+  }
+
+
+
+  int MPI_Improbe_endpoint(int src, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status)
+  {
     int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
     int mpi_rank    = comm->ep_comm_ptr->size_rank_info[2].first;
+
     *flag = false;
-    if(!comm->is_ep)
-    {
-      Debug("calling MPI_Improbe MPI\n");
-
-      ::MPI_Status mpi_status;
-      ::MPI_Message mpi_message;
-
-      #ifdef _openmpi
-      #pragma omp critical (_mpi_call)
-      {
-        ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, &mpi_status);
-        if(*flag)
-        {
-          ::MPI_Mprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), &mpi_message, &mpi_status);
-        }
-      }
-      #elif _intelmpi
-    	::MPI_Improbe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, &mpi_message, &mpi_status);
-      #endif
-    	
-      status->mpi_status = &mpi_status;
-      status->ep_src = src;
-      status->ep_tag = tag;
-
-      (*message)->mpi_message = &message;
-      (*message)->ep_src = src;
-      (*message)->ep_tag = tag;
-      
-      
-      return 0;
-    }
-
-   
-
+    
+    Message_Check(comm);
+    
     #pragma omp flush
 
@@ -146,2 +183,3 @@
 }
 
+
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp	(revision 1539)
@@ -40,4 +40,9 @@
   {
     if(!comm->is_ep) return MPI_Irecv_mpi(buf, count, datatype, src, tag, comm, request);
+
+    if(comm->is_intercomm)
+    {
+      if(src>=0) src = comm->inter_rank_map->at(src);
+    }
     
     Debug("MPI_Irecv with EP");
@@ -54,6 +59,6 @@
     (*request)->comm = comm;
     (*request)->type = 2;
+    (*request)->probed = false;
     (*request)->state = 0;
-    
 
     (*request)->ep_src = src;
@@ -63,5 +68,5 @@
     if(EP_PendingRequests == 0 ) EP_PendingRequests = new std::list< MPI_Request* >;
 
-    EP_PendingRequests->push_back(request);  
+    EP_PendingRequests->push_back(request); 
     
     memcheck("EP_PendingRequests["<<ep_rank<<"]->size() = " << EP_PendingRequests->size());    
@@ -100,4 +105,6 @@
     memcheck("delete " << (*message)->mpi_message << " : in ep_lib::MPI_Mrecv, delete (*message)->mpi_message");
     delete (*message)->mpi_message;
+    memcheck("delete " << *message << " : in ep_lib::MPI_Imrecv, delete *message");
+    delete *message;
 
 #ifdef _check_sum
@@ -118,4 +125,5 @@
     (*request)->ep_src = (*message)->ep_src;
     
+    (*request)->probed = true;
     (*request)->state = 1;
 	
@@ -125,4 +133,5 @@
     delete (*message)->mpi_message;
 
+
 #ifdef _check_sum
     check_sum_recv(buf, count, datatype, message->ep_src, message->ep_tag);
@@ -130,5 +139,5 @@
 
     
-    return Request_Check();
+    //return Request_Check();
   }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_reduce.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_reduce.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_reduce.cpp	(revision 1539)
@@ -288,8 +288,6 @@
   {
 
-    if(!comm->is_ep && comm->mpi_comm)
-    {
-      return ::MPI_Reduce(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), root, to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Reduce(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), root, to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Reduce_intercomm(sendbuf, recvbuf, count, datatype, op, root, comm);
 
 
@@ -339,4 +337,9 @@
 
 
+  int MPI_Reduce_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, int root, MPI_Comm comm)
+  {
+    printf("MPI_Reduce_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
 }
 
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_reduce_scatter.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_reduce_scatter.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_reduce_scatter.cpp	(revision 1539)
@@ -19,8 +19,6 @@
   int MPI_Reduce_scatter(const void *sendbuf, void *recvbuf, const int recvcounts[], MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
   {
-    if(!comm->is_ep)
-    {
-      return ::MPI_Reduce_scatter(sendbuf, recvbuf, recvcounts, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Reduce_scatter(sendbuf, recvbuf, recvcounts, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Reduce_scatter_intercomm(sendbuf, recvbuf, recvcounts, datatype, op, comm);
 
 
@@ -81,4 +79,10 @@
   }
 
+  int MPI_Reduce_scatter_intercomm(const void *sendbuf, void *recvbuf, const int recvcounts[], MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
+  {
+    printf("MPI_Reduce_scatter_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
+
   
 }
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_request.hpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_request.hpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_request.hpp	(revision 1539)
@@ -21,4 +21,5 @@
                  // 1: imrecvd
                  // 2: tested or waited
+      bool probed;
                    
       void* buf;
Index: /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scan.cpp
===================================================================
--- /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scan.cpp	(revision 1538)
+++ /XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scan.cpp	(revision 1539)
@@ -350,8 +350,6 @@
   int MPI_Scan(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
   {
-    if(!comm->is_ep)
-    {
-      return ::MPI_Scan(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
-    }
+    if(!comm->is_ep) return ::MPI_Scan(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
+    if(comm->is_intercomm) return MPI_Scan_intercomm(sendbuf, recvbuf, count, datatype, op, comm);
     
     valid_type(datatype);
@@ -446,3 +444,9 @@
   }
 
+  int MPI_Scan_intercomm(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
+  {
+    printf("MPI_Scan_intercomm not yet implemented\n");
+    MPI_Abort(comm, 0);
+  }
+
 }
